      subroutine inwardh(n,energy,wfn,l,rv,h,match,rin,nmx,a,b)
!  pgm to integrate inward the radial schroedinger homogeneous equation
!    at energy 'energy' and at angular momentum l until the point match
!
!    with potential rv/r, given in uniform mesh of n points
!   r=i*h, i=1,...n-1 ;assuming p(r)=C*r**(l+1)*polynomial(r) for r==0;
!                               p((n+1)*h)=0
!  uses Noumerov algorithm
!
!
      implicit real*8 (a-h,o-z)
      parameter (vlrg=1.d30)
      dimension rv(n),wfn(n)
      dimension a(nmx),b(nmx)
      ierr=0
      if (n.gt.nmx) then
       write(6,*) 'error in inwardh -- n,nmx = ',n,nmx
       stop
       endif
      angm=l*(l+1)
      eh2=energy*h*h
      do 10 i=1,n
      a(i)=angm/(i*i)+h*rv(i)/i
   10 continue
      do 12 i=1,n
      b(i)=-1.2d0+0.1d0*a(i)
   12 continue
      ssl=0.1d0
      ssd=1.d0
      do 14 i=1,n
   14 a(i)=2.4d0+a(i)
!
!  start inward integration
      wfn(1:n)=0.d0  !call dcopy (n,0.d0,0,wfn,1)
      r=n*h
      r2=r*r
      veff=rv(n)/n+rv(n-1)/(n-1)
      veff=0.5d0*veff/h+angm/r2
      ppp=sqrt(abs(veff-energy))
      j=n
      wfn(j)=1.d0/sqrt(ppp)
       rvp1=2*rv(j)-rv(j-1)
       bnp1=-1.2d0+0.1d0*(h*rvp1/(j+1)+angm/(j+1)**2)
      r=r+h
      r2=r*r
      pppp1=sqrt(abs(rvp1/r+angm/r2-energy))
      arg=0.5d0*(ppp+pppp1)*h
      pnp1=exp(-arg)/sqrt(pppp1)
      wfn(j-1)=((a(j)-eh2*ssd)*wfn(j)+                                  &
         (bnp1-eh2*ssl)*pnp1)/(eh2*ssl-b(j-1))
      j=j-1
 4001 j=j-1
      wfn(j)=((a(j+1)-eh2*ssd)*wfn(j+1)+                                &
         (b(j+2)-eh2*ssl)*wfn(j+2))/(eh2*ssl-b(j))
!  if wavefunction too large, renormalize
      if (abs(wfn(j)).gt.vlrg) then
       many=n-j+1
       scale=1.d0/vlrg
       wfn(j:j+many-1)=wfn(j:j+many-1)*scale ! call dscal(many,scale,wfn(j),1)
       endif
!  step inward until j = match - 1
      if (j.ge.match) go to 4001
      rin=(wfn(match+1)-wfn(match-1))/(2*h*wfn(match))
!     write(6,*) ' match point = ',match,rin,wfn(match)
      return
       end
