       subroutine thomas(n,a,b,c,d)
       implicit real*8(a-h,o-z)
!  subroutine to use Thomas's algorithm to solve tridiagonal matrix
!   Dale U. von Rosenberg, "Methods for the Numerical Solution of
!     Partial Differential Equations, Am. Elsevier Pub., 1969, pg. 113
!      a(i)*u(i-1)+b(i)*u(i)+c(i)*u(i+1)=d(i)
!      a(1)=c(n)==0
!      upon return, d(i)=u(i), a,b, & c modified
       dimension a(n),b(n),c(n),d(n)
       if (n.lt.1) then
        write(6,*) '***error in thomas -- n = ',n
        return
        else if (n.eq.1) then
         d(1)=d(1)/b(1)
         return
         else
           do i=2,n
           b(i)=b(i)-a(i)*c(i-1)/b(i-1)
           enddo
           d(1)=d(1)/b(1)
           do i=2,n
           d(i)=(d(i)-a(i)*d(i-1))/b(i)
           enddo
           do i=n-1,1,-1
           d(i)=d(i)-c(i)*d(i+1)/b(i)
           enddo
         endif
         return
          end
